#!/bin/bash
set -e

readonly PLATFORM="$(uname -a)"
unset SUFFIX
if [[ "${PLATFORM}" == MINGW* || "${PLATFORM}" == CYGWIN* ]]; then
  SUFFIX=".exe"
fi

echo -e "\n------------------------------------------------------------------------------"
echo -e "Instrument"
echo -e "------------------------------------------------------------------------------\n"

make clean
make FPGO=generate -B "$@"

echo -e "\n------------------------------------------------------------------------------"
echo -e "Profiling"
echo -e "------------------------------------------------------------------------------\n"

./frontend/bin/slunkcrypt${SUFFIX} -t

echo -e "\n------------------------------------------------------------------------------"
echo -e "Re-compile"
echo -e "------------------------------------------------------------------------------\n"

make FPGO=use -B "$@"
